program Wurmspiel_V2_0_Editor;
uses crt,dos,graph,vgapro,wurmtool;
var feld:^feldtyp;
    datei:file of feldtyp;
    level,dir:integer;
    c:char;
    passby:string;

procedure showfeld;
var x,y:byte;
begin
setfillstyle(1,0);
for x:=0 to 127 do begin
for y:=0 to 87 do begin
bar(x*5,y*5+40,x*5+4,y*5+44);
if (feld^[x,y]>0) and (feld^[x,y]<11) then putimage(x*5,y*5+40,steine[feld^[x,y]]^,0);
if feld^[x,y]>10 then begin
 case feld^[x,y] of
   11:putimage(x*5,y*5+40,wurmkopf[1].n^,0);
   12:putimage(x*5,y*5+40,wurmkopf[1].o^,0);
   13:putimage(x*5,y*5+40,wurmkopf[1].s^,0);
   14:putimage(x*5,y*5+40,wurmkopf[1].w^,0);
   15:putimage(x*5,y*5+40,wurmkopf[2].n^,0);
   16:putimage(x*5,y*5+40,wurmkopf[2].o^,0);
   17:putimage(x*5,y*5+40,wurmkopf[2].s^,0);
   18:putimage(x*5,y*5+40,wurmkopf[2].w^,0);
 end;
end;
end;
end;
end;

procedure ellipse(x,y,xrad,yrad:word;stein:byte);
var i,xp,yp:word;
    punkte:word;
    k:real;
begin
 punkte:=round((xrad+yrad)*10);
  for i:=1 to punkte do begin
   k:=360/punkte;
    xp:=x+round(xrad*(cos((i*k)*pi/180)));
    yp:=y-round(yrad*(sin((i*k)*pi/180)));
    feld^[xp,yp]:=stein;
  end;
 showfeld;
end;

procedure balken(x1,y1,x2,y2:word;stein:byte);
var ix,iy:word;
begin
if y2<y1 then begin iy:=y2;y2:=y1;y1:=iy;end;
  for iy:=y1 to y2 do begin
    if x2>=x1 then begin
    for ix:=x1 to x2 do begin
      feld^[ix,iy]:=stein;
    end;
    end else begin
    for ix:=x1 downto x2 do begin
      feld^[ix,iy]:=stein;
    end;
    end;
  end;
showfeld;
end;

procedure linie(x1,y1,x2,y2:word;stein:byte);
var i,xdr,ydr,punkte,ablage,dx,dy:integer;
    tanx,tany:real;
begin
 if x2<x1 then begin
   ablage:=x1;x1:=x2;x2:=ablage;ablage:=y1;y1:=y2;y2:=ablage;
 end;
   if (y2>y1) and not (x1=x2) then begin     
     tanx:=(y2-y1)/(x2-x1);
     tany:=(x2-x1)/(y2-y1);
      if tanx<=1 then punkte:=x2-x1 else punkte:=y2-y1;
        for i:=1 to punkte do begin
         if abs(tanx)<1 then feld^[x1+i,y1+round(tanx*i)]:=stein;
         if abs(tanx)>=1 then feld^[x1+round(tany*i),y1+i]:=stein;
      end;
   end;
   if (y2=y1) or (x1=x2) then balken(x1,y1,x2,y2,stein);
   if (y1>y2) and not (x1=x2) then begin
     tanx:=(y1-y2)/(x2-x1);
     tany:=(x2-x1)/(y1-y2);
      if tanx<1 then punkte:=x2-x1 else punkte:=y1-y2;
        for i:=1 to punkte do begin
         if abs(tanx)<1 then feld^[x1+i,y1-round(tanx*i)]:=stein;
         if abs(tanx)>=1 then feld^[x1+round(tany*i),y1-i]:=stein;
      end;
   end;
 showfeld;
end;


procedure loadlevel;
var x,y:byte;
    txt:string;
    b:byte;
begin
setfillstyle(1,26);
bar(5,5,630,34);
outtextxy(320,17,'Passwort: =>');
readstring(420,17,26,8,passby);
level:=1;
for b:=1 to 100 do begin
  if levelnamen[b]=passby then level:=b;
end;
setcolor(0);
if level=1 then begin
 outtextxy(110,447,'aufgehts');
 passby:=levelnamen[level];
end;
{$i-}
seek(datei,level-1);
read(datei,feld^);
{$i+}
if ioresult<>0 then begin
for x:=0 to 127 do begin
  for y:=0 to 87 do begin
    if (x=0) or (x=127) or (y=0) or (y=87) then feld^[x,y]:=1 else feld^[x,y]:=0;
  end;
end;
end;
showfeld;
str(level,txt);
outtextxy(10,457,'Level : '+txt);
end;
procedure draw;
var wahl:byte;
    txt,txt2:string;
    xpos,ypos,xn,yn:byte;
begin
setfillstyle(1,26);
bar(5,5,630,34);
setcolor(0);
showfeld;
seek(datei,level-1);
str(level,txt);
outtextxy(320,7,'Level : '+txt);
outtextxy(320,17,'Passwort: => '+passby);
outtextxy(10,7,'Steinwahl:');
outtextxy(55,17,'<F1>');
putimage(90,18,steine[1]^,0);
outtextxy(55,27,'<F2>');
putimage(90,28,steine[2]^,0);
outtextxy(100,17,'<F3>');
putimage(135,18,steine[4]^,0);
outtextxy(100,27,'<F4>');
putimage(135,28,steine[5]^,0);
outtextxy(145,17,'<F5>');
putimage(180,18,steine[7]^,0);
outtextxy(145,27,'<F6>');
putimage(180,28,steine[8]^,0);
outtextxy(190,17,'<F7>');
putimage(225,18,steine[9]^,0);
outtextxy(190,27,'<F8>');
putimage(225,28,steine[10]^,0);
outtextxy(230,17,'<F9>');
setcolor(0);
rectangle(269,17,275,23);
putimage(270,18,wurmkopf[1].w^,0);
outtextxy(230,27,'<F10>');
setcolor(0);
rectangle(269,27,275,33);
putimage(270,28,wurmkopf[2].w^,0);
outtextxy(150,7,'<ESC> -> Men');
xpos:=64;
ypos:=44;
wahl:=1;
repeat
setcolor(5);
rectangle(xpos*5,ypos*5+40,xpos*5+4,ypos*5+44);
setfillstyle(1,26);
bar(350,26,630,36);
str(xpos,txt);
str(ypos,txt2);
setcolor(0);
outtextxy(320,27,'Position : X '+txt+' / Y '+txt2);
c:=readkey;
setcolor(0);
rectangle(xpos*5,ypos*5+40,xpos*5+4,ypos*5+44);
if (feld^[xpos,ypos]>0) and (feld^[xpos,ypos]<11) then putimage(xpos*5,ypos*5+40,steine[feld^[xpos,ypos]]^,0);
if feld^[xpos,ypos]>10 then begin
 case feld^[xpos,ypos] of
   11:putimage(xpos*5,ypos*5+40,wurmkopf[1].n^,0);
   12:putimage(xpos*5,ypos*5+40,wurmkopf[1].o^,0);
   13:putimage(xpos*5,ypos*5+40,wurmkopf[1].s^,0);
   14:putimage(xpos*5,ypos*5+40,wurmkopf[1].w^,0);
   15:putimage(xpos*5,ypos*5+40,wurmkopf[2].n^,0);
   16:putimage(xpos*5,ypos*5+40,wurmkopf[2].o^,0);
   17:putimage(xpos*5,ypos*5+40,wurmkopf[2].s^,0);
   18:putimage(xpos*5,ypos*5+40,wurmkopf[2].w^,0);
 end;
end;
case c of
 'd':wahl:=0;
 'l':begin
          xn:=xpos;yn:=ypos;     
          repeat
           setcolor(5);
           rectangle(xpos*5,ypos*5+40,xpos*5+4,ypos*5+44);
           setfillstyle(1,26);
           bar(350,26,630,36);
           str(xpos,txt);
           str(ypos,txt2);
           setcolor(0);
           outtextxy(320,27,'Position : X '+txt+' / Y '+txt2);
           c:=readkey;
           setcolor(0);
           rectangle(xpos*5,ypos*5+40,xpos*5+4,ypos*5+44);
           if (feld^[xpos,ypos]>0) and (feld^[xpos,ypos]<11) then putimage(xpos*5,ypos*5+40,steine[feld^[xpos,ypos]]^,0);
           case c of
              'd','D':wahl:=0;
              #59:wahl:=1;
              #60:wahl:=2;
              #61:wahl:=4;
              #62:wahl:=5;
              #63:wahl:=7;
              #64:wahl:=8;
              #65:wahl:=9;
              #66:wahl:=10;
              #72:dec(ypos);
              #80:inc(ypos);
              #77:inc(xpos);
              #75:dec(xpos);
              #13,#32:linie(xn,yn,xpos,ypos,wahl);
           end;
           until (c=#27) or (c=#13) or (c=#32);
         end;
 'e':begin
          xn:=xpos;yn:=ypos;     
          repeat
           setcolor(5);
           rectangle(xpos*5,ypos*5+40,xpos*5+4,ypos*5+44);
           setfillstyle(1,26);
           bar(350,26,630,36);
           str(xpos,txt);
           str(ypos,txt2);
           setcolor(0);
           outtextxy(320,27,'Position : X '+txt+' / Y '+txt2);
           c:=readkey;
           setcolor(0);
           rectangle(xpos*5,ypos*5+40,xpos*5+4,ypos*5+44);
           if (feld^[xpos,ypos]>0) and (feld^[xpos,ypos]<11) then putimage(xpos*5,ypos*5+40,steine[feld^[xpos,ypos]]^,0);
           case c of
              #59:wahl:=1;
              #60:wahl:=2;
              #61:wahl:=4;
              #62:wahl:=5;
              #63:wahl:=7;
              #64:wahl:=8;
              #65:wahl:=9;
              #66:wahl:=10;
              #72:dec(ypos);
              #80:inc(ypos);
              #77:inc(xpos);
              #75:dec(xpos);
              #13,#32:ellipse(xn,yn,xpos,ypos,wahl);
           end;
           until (c=#27) or (c=#13) or (c=#32);   
         end;     
 'b':begin
         xn:=xpos;yn:=ypos;     
          repeat
           setcolor(5);
           rectangle(xpos*5,ypos*5+40,xpos*5+4,ypos*5+44);
           setfillstyle(1,26);
           bar(350,26,630,36);
           str(xpos,txt);
           str(ypos,txt2);
           setcolor(0);
           outtextxy(320,27,'Position : X '+txt+' / Y '+txt2);
           c:=readkey;
           setcolor(0);
           rectangle(xpos*5,ypos*5+40,xpos*5+4,ypos*5+44);
           if (feld^[xpos,ypos]>0) and (feld^[xpos,ypos]<11) then putimage(xpos*5,ypos*5+40,steine[feld^[xpos,ypos]]^,0);
           case c of
              #59:wahl:=1;
              #60:wahl:=2;
              #61:wahl:=4;
              #62:wahl:=5;
              #63:wahl:=7;
              #64:wahl:=8;
              #65:wahl:=9;
              #66:wahl:=10;
              #72:dec(ypos);
              #80:inc(ypos);
              #77:inc(xpos);
              #75:dec(xpos);
              #13,#32:balken(xn,yn,xpos,ypos,wahl);
           end;
           until (c=#27) or (c=#13) or (c=#32);
         end;
 #59:wahl:=1;
 #60:wahl:=2;
 #61:wahl:=4;
 #62:wahl:=5;
 #63:wahl:=7;
 #64:wahl:=8;
 #65:wahl:=9;
 #66:wahl:=10;
 #67:wahl:=100;
 #68:wahl:=200;
 #72:dec(ypos);
 #80:inc(ypos);
 #77:inc(xpos);
 #75:dec(xpos);
 #13,#32: begin
      if feld^[xpos,ypos]=0 then feld^[xpos,ypos]:=wahl else feld^[xpos,ypos]:=0;
      if wahl=100 then begin
        setcolor(0);
        outtextxy(500,17,'Richtung?');
        line(620,7,620,27);line(610,17,630,17);
        line(617,10,620,7);line(623,10,620,7);
        line(613,14,610,17);line(613,20,610,17);
        line(617,24,620,27);line(623,24,620,27);
        line(627,14,630,17);line(627,20,630,17);
        dir:=0;
        repeat
        c:=readkey;
         case c of
           #72:dir:=1;
           #80:dir:=3;
           #77:dir:=2;
           #75:dir:=4;
         end;
        until dir>0;
        c:=' ';
        feld^[xpos,ypos]:=10+dir;
        setfillstyle(1,26);
        bar(500,7,630,27);
      end;
      if wahl=200 then begin
        setcolor(0);
        outtextxy(500,17,'Richtung?');
        line(620,7,620,27);line(610,17,630,17);
        line(617,10,620,7);line(623,10,620,7);
        line(613,14,610,17);line(613,20,610,17);
        line(617,24,620,27);line(623,24,620,27);
        line(627,14,630,17);line(627,20,630,17);
        dir:=0;
        repeat
        c:=readkey;
         case c of
           #72:dir:=1;
           #80:dir:=3;
           #77:dir:=2;
           #75:dir:=4;
         end;
        until dir>0;
        c:=' ';
        feld^[xpos,ypos]:=14+dir;
        setfillstyle(1,26);
        bar(500,7,630,27);
      end;
      showfeld;
      end;
 end;
if xpos<1 then xpos:=1;
if xpos>126 then xpos:=126;
if ypos<1 then ypos:=1;
if ypos>86 then ypos:=86;
until c=#27;
c:='A';
end;

{procedure saveallelevel;(*1 - 100 "lschen"*)
var a: byte;
begin
assign(datei,'wurm256.dat'); }
{rewrite(datei);
for a:=1 to 100 do begin
write(datei,feld^);
end;
end;     }
procedure speicher;
var x,y:byte;
    w1,w2:integer;
begin
w1:=0;
w2:=0;
for x:=0 to 127 do begin
for y:=0 to 87 do begin
  if (feld^[x,y]>10) and (feld^[x,y]<15) then inc(w1);
  if (feld^[x,y]>14) and (feld^[x,y]<19) then inc(w2);
end;
end;
if (w1<>1) or (w2<>1) then begin
setcolor(10);
outtextxy(320,27,'Speichern nicht mglich');
delay(1000);
exit;
end;
seek(datei,level-1);
write(datei,feld^);
end;

begin
new(feld);
level:=1;
assign(datei,'Wurm256.dat');
{$i-}
reset(datei);
{$i+}
if ioresult<>0 then rewrite(datei);
initialize256(2);
wurmdef;
steinedef;
passby:='aufgehts';
repeat
drawdoublemenu(0,0,639,39,2,26,5,27);
setcolor(0);
outtextxy(10,6,' <F1> Neues Level');
outtextxy(10,16,' <F2> Level bearbeiten');
outtextxy(10,26,' <F3> Level speichern');
outtextxy(320,6,' 2*<ESC> Ende');
c:=readkey;
case c of
#59:begin loadlevel;end;
#60:begin Draw;end;
#61:begin Speicher;end;
#27:c:=readkey;
end;
until c=#27;
closegraph;
close(datei);
dispose(feld);
end.
